SystemOrganization addCategory: #ConfigurationOfWebDoc!

Object subclass: #ConfigurationOfWebDoc
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfWebDoc'!

!ConfigurationOfWebDoc commentStamp: 'YuriyTymchuk 5/15/2014 21:42' prior: 0!
I export documentation to web.!

!ConfigurationOfWebDoc class methodsFor: 'private' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 22:32'!
catalogChangeLog
	^ 'https://github.com/estebanlm/pharo-webdoc/commits/master'! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 22:32'!
catalogContactInfo
	^ 'https://github.com/estebanlm'! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 22:32'!
catalogDescription
	^ 'I export documentation to web'! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 22:33'!
catalogKeyClassesAndExample
	^ '(WebDocExporter packages: RPackageOrganizer default packages) exportTo: ''./doc'' asFileReference.'! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 22:33'!
catalogKeywords
	^ #(website doc documetation)! !

!ConfigurationOfWebDoc class methodsFor: 'private' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfWebDoc class methodsFor: 'private' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfWebDoc class methodsFor: 'metacello tool support' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfWebDoc class methodsFor: 'loading' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfWebDoc class methodsFor: 'loading' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfWebDoc class methodsFor: 'accessing' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
project

	^self new project! !

!ConfigurationOfWebDoc class methodsFor: 'development support' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfWebDoc methodsFor: 'baselines' stamp: 'YuriyTymchuk 5/15/2014 21:48'!
baseline03: spec
	<version: '0.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'github://estebanlm/pharo-webdoc:master/mc'.

		spec project: 'Petit Markdown' with: [
			spec
				className: 'ConfigurationOfPPMarkdown';
				version: #'development';
				repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main' ].

		spec project: 'Seaside3' with: [
			spec
				repository: 'http://smalltalkhub.com/mc/Seaside/MetacelloConfigurations/main';
				className: 'ConfigurationOfSeaside3';
				loads: #('default' 'REST');
				version: #'stable' ].

		spec 
			package: 'WebDoc' with: [
				spec requires: #('Petit Markdown' 'Seaside3') ]]! !

!ConfigurationOfWebDoc methodsFor: 'symbolic versions' stamp: 'YuriyTymchuk 5/15/2014 21:45'!
development: spec
	<symbolicVersion: #'development'>
	
	spec for: #common version: '0.3-baseline'! !

!ConfigurationOfWebDoc methodsFor: 'accessing' stamp: 'YuriyTymchuk 5/15/2014 21:42'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfWebDoc methodsFor: 'symbolic versions' stamp: 'YuriyTymchuk 5/15/2014 21:45'!
stable: spec
	<symbolicVersion: #'stable'>
	
	spec for: #common version: '0.3-baseline'! !
